#!/usr/bin/env python3

import sys
import serial
#import pynmea2
import time
#import numpy as np
import subprocess
import pickle

import os
from tkinter.ttk import Notebook
from tkinter import messagebox
from tkinter import filedialog
import tkinter as tk
import math


sys.path.insert(0, "/home/pi/Documents/PiArdumower") #add full path to avoid KST plot error on path

class streamVideo_class(object):
    """class use to start and stop the video stream"""
    def __init__(self):
        self.streamVideo = None

    def start(self,resolution):
        self.stop()
        print(resolution)
        if resolution==0:
            self.streamVideo=subprocess.Popen(["/home/pi/Documents/PiArdumower/streamVideo320.py","shell=True","stdout=subprocess.PIPE"])
        if resolution==1:
            self.streamVideo=subprocess.Popen(["/home/pi/Documents/PiArdumower/streamVideo640.py","shell=True","stdout=subprocess.PIPE"])
        
    def stop(self):
        if self.streamVideo:
            self.streamVideo.kill()
            self.streamVideo.wait()
            self.streamVideo = None
            
myStreamVideo=streamVideo_class()

class gpsRecord_class(object):
    #*****************************class used to start and stop the gps Record********************************
    def __init__(self):
        self.gpsRecord = None

    def start(self):
        self.stop()
        self.gpsRecord=subprocess.Popen(["/home/pi/Documents/PiArdumower/gpsrecord.py","shell=True","stdout=subprocess.PIPE"])
        
    def stop(self):
        if self.gpsRecord:
            self.gpsRecord.kill()
            self.gpsRecord.wait()
            self.gpsRecord = None
            
mygpsRecord=gpsRecord_class()


actualRep=os.getcwd()
dateNow=time.strftime('%d/%m/%y %H:%M:%S',time.localtime())

fen1 =tk.Tk()

"""variable use into Auto Menu"""
tk_batVoltage=tk.DoubleVar()
#tk_ImuYaw=tk.DoubleVar()
#tk_ImuPitch=tk.DoubleVar()
#tk_ImuRoll=tk.DoubleVar()
tk_Dht22Temp=tk.DoubleVar()
#tk_Dht22Humid=tk.DoubleVar()


CamVar1=tk.IntVar()


fen1.title('ARDUMOWER')
fen1.geometry("800x480")


def MainLoop():  #*******************************the main loop is here
    byteResponse=ser.readline()
    
    if str(byteResponse)!="b''": #receive OK
        strResponse=byteResponse.decode('UTF-8') #change byte to string
        if strResponse[:1] != '$' : # the first digit is not $ so nothing to do except terminal print
            txtConsoleRecu.insert('1.0', strResponse)
            
        
        if strResponse[:1] == '$': # the first digit is $ so something to do
            sensor,value=strResponse.split(",")
            if sensor=='$temp':
                tk_Dht22Temp=(float(value))
                
            if sensor=='$batV':
                tk_batVoltage=(float(value))
                   




        
           
        
    fen1.after(10,MainLoop)  # 10 here is the main loop each 10ms

    
def ButtonSaveReceived_click():
    fileName="/home/pi/Documents/PiArdumower/log/" + time.strftime("%Y%m%d%H%M") + "_Received.txt" 
    with open(fileName,"w") as f:
        f.write(txtRecu.get('1.0','end'))
    fileName="/home/pi/Documents/PiArdumower/log/" + time.strftime("%Y%m%d%H%M") + "_Send.txt"
    with open(fileName,"w") as f:
        f.write(txtSend.get('1.0','end'))
    fileName="/home/pi/Documents/PiArdumower/log/" + time.strftime("%Y%m%d%H%M") + "_Console.txt"
    with open(fileName,"w") as f:
        f.write(txtConsoleRecu.get('1.0','end'))

    txtConsoleRecu.insert('1.0', 'All Console file are saved')
    

    
def ButtonForward_click():
    ButtonReverse.configure(state='disabled')
    #send_var_message('w','motorSpeedMaxPwm',''+str(manualSpeedSlider.get())+'','0','0','0','0','0','0','0')
    send_terminal_message('clc.v,60')
def ButtonRight_click():
    send_terminal_message('turnto,60,60')
def ButtonLeft_click():
    send_terminal_message('turnto,-60,60')
def ButtonReverse_click():
    ButtonForward.configure(state='disabled')
    send_terminal_message('clc.v,-30')
def ButtonStop_click():
    ButtonForward.configure(state='normal')
    ButtonReverse.configure(state='normal')
    send_terminal_message('clc.s')
     

def button_home_click():
    send_terminal_message('gohome')
    
def button_track_click():
    send_terminal_message('tpt')

def button_stop_all_click():
    send_terminal_message('M')


    
def ButtonCamera_click():
    StreamVideoPage.tkraise()
    
def ButtonGps_click():
    GpsPage.tkraise()

def ButtonSchedule_click():
    TabTimer.tkraise()

    
def ButtonPowerOff_click():
    returnval=messagebox.askyesno('Info',"Are you sure you want to shutdown all the PCB ?")
    if returnval :
        send_terminal_message('PowerOff')

    
def ButtonStartMow_click():
    send_terminal_message('A')
   
def buttonBlade_stop_click():
    send_terminal_message('t')
    
def buttonBlade_start_click():
    send_terminal_message('z')

def ButtonManual_click():
    send_terminal_message('M')
    ManualPage.tkraise()
        
def ButtonPlot_click():
    TabPlot.tkraise()

def ButtonSetting_click():
    TabSetting.tkraise()
   
def ButtonBackToMain_click():
    MainPage.tkraise()   
                    
def ButtonConsole_click():
    ConsolePage.tkraise()

def ButtonTest_click():
    TestPage.tkraise()
    
def ButtonAuto_click():
    AutoPage.tkraise()
    
   

def ButtonOdo1TurnFw_click():
    send_terminal_message('h')
def ButtonOdo5TurnFw_click():
    send_terminal_message('M')
def ButtonOdo1TurnRev_click():
    send_terminal_message('A')
def ButtonOdo5TurnRev_click():
    send_terminal_message('reset')
def ButtonOdo3MlFw_click():
    send_terminal_message('Batery.show') 
def ButtonOdoRot180_click():
    send_terminal_message('per.show')
def ButtonOdoRot360_click():
    send_terminal_message('temp.show')
def ButtonOdoRotNonStop_click():
    send_terminal_message('bht.tri')
def BtnReset_click():
    send_terminal_message('reset')
def BtnHelp_click():
    send_terminal_message('H')
def BtnManual_click():
    send_terminal_message('M')
def Btn111_click():
    send_terminal_message('temp.show')
def Btn112_click():
    send_terminal_message('bat.show')
    
   
        
def send_terminal_message(val1):
    message = val1
    message=str(message)
    message=message + '\r' +'\n'
    try:
            MainLoop()
            ser.flushOutput() #clear the output buffer
            ser.write(bytes(message,'utf-8'))
            #print("Send Message :" , message)
            txtSend.insert('1.0',  message) 
            
    except :
            print("ERREUR while transfert")
            time.sleep(2)


#Initialise the serial line response is normaly 'b'
try:
        ser = serial.Serial('/dev/ttyACM0',115200,timeout=0)
        byteResponse=ser.readline()
        print(str(byteResponse))
        
        
except:
        print("ERREUR DE CONNECTION")
        time.sleep(2)
        #sys.exit("Impossible de continuer")




#*************************************************************************************************
#******************************* THE AUTO PAGE ***************************************************

imgHome=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/home.png")
imgTrack=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/track.png")
imgStopAll=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/stop all.png")
imgstartMow=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/startmow.png")

AutoPage = tk.Frame(fen1)
AutoPage.place(x=0, y=0, height=400, width=800)

Frame2= tk.Frame(AutoPage)
Frame2.place(x=10, y=180, height=60, width=100)
Frame2.configure(borderwidth="3",relief=tk.GROOVE,background="#d9d9d9",highlightbackground="#d9d9d9",highlightcolor="black")

tk.Label(Frame2,text="BATTERY",fg='green').pack(side='top',anchor='n')
tk.Label(Frame2,textvariable=tk_batVoltage, fg='red',font=("Arial", 20)).pack(side='bottom',anchor='n')

Frame3= tk.Frame(AutoPage)
Frame3.place(x=130, y=180, height=60, width=100)
Frame3.configure(borderwidth="3",relief=tk.GROOVE,background="#d9d9d9",highlightbackground="#d9d9d9",highlightcolor="black")

tk.Label(Frame3,text="TEMPERATURE",fg='green').pack(side='top',anchor='n')
tk.Label(Frame3,textvariable=tk_Dht22Temp, fg='red',font=("Arial", 20)).pack(side='bottom',anchor='n')



Frame1 = tk.Frame(AutoPage)
Frame1.place(x=10, y=20, height=150, width=130)
tk.Label(Frame1,text="Battery",fg='green').pack(side='top',anchor='w')
#RdBtn_Random=tk.Radiobutton(Frame1, text="Random", variable=tk_mowingPattern, value=0).pack(side='top',anchor='w')
#RdBtn_ByLane=tk.Radiobutton(Frame1, text="By Lane", variable=tk_mowingPattern, value=1).pack(side='top',anchor='w')
#RdBtn_Perimeter=tk.Radiobutton(Frame1, text="Perimeter", variable=tk_mowingPattern, value=2).pack(side='top',anchor='w')
ButtonStartMow = tk.Button(AutoPage, image=imgstartMow, command = ButtonStartMow_click)
ButtonStartMow.place(x=130,y=0,width=100, height=130)
Buttonhome = tk.Button(AutoPage, image=imgHome, command = button_home_click)
Buttonhome.place(x=250,y=0,width=100, height=130)
Buttontrack = tk.Button(AutoPage, image=imgTrack, command = button_track_click)
Buttontrack.place(x=380,y=0,width=100, height=130)
ButtonStopAllAuto = tk.Button(AutoPage, image=imgStopAll, command = button_stop_all_click)
ButtonStopAllAuto.place(x=500,y=0,width=100, height=130)



#*****************************************************************************************
#**************************THE MANUAL PAGE  **********************************************
ManualPage = tk.Frame(fen1)
ManualPage.place(x=0, y=0, height=430, width=800)
Frame1 = tk.Frame(ManualPage)
Frame1.place(x=0, y=0, height=300, width=300)

imgBladeStop = tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/bladeoff.png")
imgBladeStart = tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/bladeon.png")
imgForward=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/forward.png")
imgReverse=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/reverse.png")
imgLeft=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/left.png")
imgRight=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/right.png")
imgStop=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/stop.png")



ButtonForward = tk.Button(Frame1,image=imgForward, command = ButtonForward_click)
ButtonForward.place(x=100, y=0, height=100, width=100)

ButtonStop = tk.Button(Frame1,image=imgStop, command = ButtonStop_click)
ButtonStop.place(x=100, y=100, height=100, width=100)

ButtonRight = tk.Button(Frame1,image=imgRight, command = ButtonRight_click)
ButtonRight.place(x=200, y=100, height=100, width=100)

ButtonLeft = tk.Button(Frame1,image=imgLeft, command = ButtonLeft_click)
ButtonLeft.place(x=0, y=100, height=100, width=100)

ButtonReverse = tk.Button(Frame1,image=imgReverse,command = ButtonReverse_click)
ButtonReverse.place(x=100,y=200, height=100, width=100)

ButtonBladeStart = tk.Button(ManualPage, image=imgBladeStart, command = buttonBlade_start_click)
ButtonBladeStart.place(x=500,y=80,width=100, height=50)
ButtonBladeStop = tk.Button(ManualPage, image=imgBladeStop, command = buttonBlade_stop_click)
ButtonBladeStop.place(x=500,y=130,width=100, height=80)



ButtonStopAllManual = tk.Button(ManualPage, image=imgStopAll, command = button_stop_all_click)
ButtonStopAllManual.place(x=500,y=250,width=100, height=130)


manualSpeedSlider = tk.Scale(ManualPage,orient='horizontal', from_=0, to=255)
manualSpeedSlider.place(x=0,y=300,width=300, height=80)
tk.Label(ManualPage, text='SPEED',fg='green').place(x=0,y=300)



#*********************************************************************************************
#************************************** The Console page  ************************************

ConsolePage = tk.Frame(fen1)
ConsolePage.place(x=0, y=0, height=430, width=800)
Frame2 = tk.Frame(ConsolePage)
Frame2.place(x=100, y=0, height=80, width=380)
Frame2.configure(relief=tk.GROOVE)
Frame2.configure(borderwidth="3")
Frame2.configure(relief=tk.GROOVE)
Frame2.configure(background="#d9d9d9")
Frame2.configure(highlightbackground="#d9d9d9")
Frame2.configure(highlightcolor="black")

txtRecu = tk.Text(ConsolePage)
ScrollTxtRecu = tk.Scrollbar(txtRecu)
ScrollTxtRecu.pack(side=tk.RIGHT, fill=tk.Y)
txtRecu.pack(side=tk.LEFT, fill=tk.Y)
ScrollTxtRecu.config(command=txtRecu.yview)
txtRecu.config(yscrollcommand=ScrollTxtRecu.set)
txtRecu.place(x=0,y=350,anchor='nw',width=400, height=100)

txtSend = tk.Text(ConsolePage)
ScrollTxtSend = tk.Scrollbar(txtSend)
ScrollTxtSend.pack(side=tk.RIGHT, fill=tk.Y)
txtSend.pack(side=tk.LEFT, fill=tk.Y)
ScrollTxtSend.config(command=txtSend.yview)
txtSend.config(yscrollcommand=ScrollTxtSend.set)
txtSend.place(x=420,y=350,anchor='nw',width=380, height=100)


txtConsoleRecu = tk.Text(ConsolePage)
ScrolltxtConsoleRecu = tk.Scrollbar(txtConsoleRecu)
ScrolltxtConsoleRecu.pack(side=tk.RIGHT, fill=tk.Y)
txtConsoleRecu.pack(side=tk.LEFT, fill=tk.Y)
ScrolltxtConsoleRecu.config(command=txtConsoleRecu.yview)
txtConsoleRecu.config(yscrollcommand=ScrolltxtConsoleRecu.set)
txtConsoleRecu.place(x=0,y=100,anchor='nw',width=800, height=250)
BtnReset= tk.Button(Frame2,command = BtnReset_click,text="Reset")
BtnReset.place(x=0,y=0, height=25, width=60)
BtnHelp= tk.Button(Frame2,command = BtnHelp_click,text="Help")
BtnHelp.place(x=65,y=0, height=25, width=60)
BtnManual= tk.Button(Frame2,command = BtnManual_click,text="Manual")
BtnManual.place(x=130,y=0, height=25, width=60)
Btn111= tk.Button(Frame2,command = Btn111_click,text="111")
Btn111.place(x=195,y=0, height=25, width=60)
Btn112= tk.Button(Frame2,command = Btn112_click,text="112")
Btn112.place(x=260,y=0, height=25, width=60)

ButtonSaveReceived = tk.Button(ConsolePage)
ButtonSaveReceived .place(x=600,y=5, height=25, width=130)
ButtonSaveReceived .configure(command = ButtonSaveReceived_click,text="Save To File")


#**********************************************************************************************************
#****************************************** THE GPS PAGE **************************************************
def BtnGpsRecordStart_click():
    mygpsRecord.start()
       
        
def BtnGpsRecordStop_click():
    mygpsRecord.stop()
        
GpsPage =tk.Frame(fen1)
GpsPage.place(x=0, y=0, height=430, width=800)
FrameGps = tk.Frame(GpsPage,borderwidth="1",relief=tk.SOLID)
FrameGps.place(x=20, y=40, width=600, height=300)
tk.Label(GpsPage, text='The gps run as service and write into directory /gpsdata/').place(x=10,y=15)
BtnGpsRecordStart= tk.Button(FrameGps,command = BtnGpsRecordStart_click,text="Start")
BtnGpsRecordStart.place(x=80,y=50, height=25, width=60)
BtnGpsRecordStop= tk.Button(FrameGps,command = BtnGpsRecordStop_click,text="Stop")
BtnGpsRecordStop.place(x=10,y=50, height=25, width=60)


#*******************************************************************************************************************
#*********************************************** THE CAMERA PAGE ***************************************************
def BtnStreamVideoStart_click():
    if CamVar1.get()==1:
        myStreamVideo.start(1)
        #webbrowser.open("http://localhost:8000/index.html")

    else:
        myStreamVideo.start(0)
        
def BtnStreamVideoStop_click():
    myStreamVideo.stop()
        

      


StreamVideoPage =tk.Frame(fen1)
StreamVideoPage.place(x=0, y=0, height=430, width=800)
FrameStreamVideo = tk.Frame(StreamVideoPage,borderwidth="1",relief=tk.SOLID)
FrameStreamVideo.place(x=20, y=30, width=600, height=300)
OptBtnStreamVideo1=tk.Radiobutton(FrameStreamVideo, text="320*240",relief=tk.SOLID,variable=CamVar1,value=0,anchor='nw').place(x=10,y=10,width=250, height=20)
OptBtnStreamVideo2=tk.Radiobutton(FrameStreamVideo, text="640*480",relief=tk.SOLID,variable=CamVar1,value=1,anchor='nw').place(x=10,y=30,width=250, height=20)
tk.Label(FrameStreamVideo, text='To view the vidéo stream use a browser http://(Your PI IP Adress and):8000/index.html').place(x=10,y=180)
BtnStreamVideoStart= tk.Button(FrameStreamVideo,command = BtnStreamVideoStart_click,text="Start")
BtnStreamVideoStart.place(x=180,y=250, height=25, width=60)
BtnStreamVideoStop= tk.Button(FrameStreamVideo,command = BtnStreamVideoStop_click,text="Stop")
BtnStreamVideoStop.place(x=10,y=250, height=25, width=60)


        
#**********************************************************************************************************************        
#**************************************************** THE TEST PAGE ***************************************************

TestPage =tk.Frame(fen1)
TestPage.place(x=0, y=0, height=430, width=800)

ButtonOdo1TurnFw = tk.Button(TestPage)
ButtonOdo1TurnFw.place(x=30,y=15, height=25, width=200)
ButtonOdo1TurnFw.configure(command = ButtonOdo1TurnFw_click)
ButtonOdo1TurnFw.configure(text="Forward 1 Turn")

ButtonOdo5TurnFw= tk.Button(TestPage)
ButtonOdo5TurnFw.place(x=30,y=65, height=25, width=200)
ButtonOdo5TurnFw.configure(command = ButtonOdo5TurnFw_click)
ButtonOdo5TurnFw.configure(text="Forward 5 Turn")

ButtonOdo1TurnRev = tk.Button(TestPage)
ButtonOdo1TurnRev.place(x=30,y=115, height=25, width=200)
ButtonOdo1TurnRev.configure(command = ButtonOdo1TurnRev_click)
ButtonOdo1TurnRev.configure(text="Reverse 1 Turn")

ButtonOdo5TurnRev= tk.Button(TestPage)
ButtonOdo5TurnRev.place(x=30,y=165, height=25, width=200)
ButtonOdo5TurnRev.configure(command = ButtonOdo5TurnRev_click)
ButtonOdo5TurnRev.configure(text="Reverse 5 Turn")

ButtonOdo3MlFw = tk.Button(TestPage)
ButtonOdo3MlFw.place(x=300,y=15, height=25, width=200)
ButtonOdo3MlFw.configure(command = ButtonOdo3MlFw_click)
ButtonOdo3MlFw.configure(text="3 Meters Forward")

ButtonOdoRot180= tk.Button(TestPage)
ButtonOdoRot180.place(x=300,y=65, height=25, width=200)
ButtonOdoRot180.configure(command = ButtonOdoRot180_click)
ButtonOdoRot180.configure(text="Rotate 180 Degree")

ButtonOdoRot360= tk.Button(TestPage)
ButtonOdoRot360.place(x=300,y=115, height=25, width=200)
ButtonOdoRot360.configure(command = ButtonOdoRot360_click)
ButtonOdoRot360.configure(text="Rotate 360 Degree")

ButtonOdoRotNonStop= tk.Button(TestPage)
ButtonOdoRotNonStop.place(x=300,y=165, height=25, width=200)
ButtonOdoRotNonStop.configure(command = ButtonOdoRotNonStop_click)
ButtonOdoRotNonStop.configure(text="Rotate Non Stop 100 Turns")









#****************************************************************************************************
#********************************** THE MAIN PAGE ***************************************************
       
imgArdumower = tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/ardumower.png")
imgManual=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/manual.png")
imgAuto=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/auto.png")
#imgTest=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/test.png")
imgConsole=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/console.png")
#imgSetting=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/setting.png")
imgPowerOff=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/off.png")
#imgPlot=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/plot.png")
#imgSchedule=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/schedule.png")
imgCamera=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/camera.png")
imgGps=tk.PhotoImage(file="/home/pi/Documents/PiArdumower/icons/gps.png")


MainPage = tk.Frame(fen1)
MainPage.place(x=0, y=0, height=480, width=800)

ButtonAuto = tk.Button(MainPage,image=imgAuto,command = ButtonAuto_click)
ButtonAuto.place(x=10,y=10, height=130, width=100)

ButtonManual = tk.Button(MainPage,image=imgManual)
ButtonManual.place(x=145,y=10, height=130, width=100)
ButtonManual.configure(command = ButtonManual_click)

ButtonCamera = tk.Button(MainPage, image=imgCamera, command = ButtonCamera_click)
ButtonCamera.place(x=280,y=10,width=100, height=130)

ButtonConsole = tk.Button(MainPage,image=imgConsole)
ButtonConsole.place(x=415,y=10, height=130, width=100)
ButtonConsole.configure(command = ButtonConsole_click)

ButtonGps = tk.Button(MainPage, image=imgGps, command = ButtonGps_click)
ButtonGps.place(x=550,y=10,width=100, height=130)

ButtonPowerOff = tk.Button(MainPage, image=imgPowerOff, command = ButtonPowerOff_click)
ButtonPowerOff.place(x=685,y=300,width=100, height=130)


MainStatusLine=tk.StringVar()

Maintext = tk.Label(MainPage, text='',textvariable=MainStatusLine,font=("Arial", 20), fg='red')
Maintext.place(x=10,y=450, height=25, width=300)



ButtonBack1 = tk.Button(MainPage)
ButtonBack1.place(x=500,y=455, height=20, width=100)
ButtonBack1.configure(command = ButtonBackToMain_click)
ButtonBack1.configure(text="Back To Main")



MainLoop()
#read_all_setting()
#read_time_setting()

fen1.mainloop()




            
            
        
