import serial_rx_tx

#from console_page import ButtonSavereceived_click
import time
from config import myComPort
from config import myBaudRate
from config import myOS
from config import cwd

from tkinter import messagebox
#import logging



class Tdata:
    
    PowerOffInitiate=False
   
    
    def __init__(self):
        self.serialPort = serial_rx_tx.SerialPort()
        self.serialPort.Open(myComPort, myBaudRate)
        self.serialPort.RegisterReceiveCallback(self.OnReceiveSerialData)
        self.ReceiveCallback = None
        self.receivedMessage = ""
        self.receivedList = []

        self.temp = 20
        self.humidity = 40
        self.batVoltage = 29
        self.GpsRmcMessage=""
        self.dueTime=""
        self.dueTimeHour = 0
        self.dueTimeMinute = 0
        self.dueTimeSecond = 0
        self.dueTimeDay = 0
        self.dueTimeMonth = 0
        self.dueTimeYear = 0
        
        #logging.basicConfig(filename=cwd + "/log/debug.log", level=logging.DEBUG)


    def RegisterReceiveCallback(self, aReceiveCallback):
        self.ReceiveCallback = aReceiveCallback

    def closeSerial(self):
        self.serialPort.Close()

    def readSerial(self):
        self.serialPort.readSerial()

    def sendData(self, message):

        if self.serialPort.IsOpen():
            message = message.rstrip(' \r\n')
            if len(message) > 0:
                message += '\r\n'
                print("SerialSend: " + message)
                self.serialPort.Send(message)
        else:
            messagebox.showinfo("Title", "Not sent - COM port is closed\r\n")

    def OnReceiveSerialData(self, message):
        self.receivedMessage = message
        #logging.info(self.receivedMessage)

        #print(self.receivedMessage)

        self.receivedList.clear()
        self.receivedList = message.split(",")

        if self.receivedList[0][:1] == '$':  # the first digit is $ so something to do

            # print out list for debugging
            #for item in self.receivedList:
                #print(item)

            if self.receivedList[0] == '$GNRMC':
                try:
                    self.GpsRmcMessage=self.receivedMessage
                    
                except Exception as e:
                   print('ERROR  $GNRMC received: ', e)

            if self.receivedList[0] == '$temp':
                try:
                    self.temp = (round(float(self.receivedList[1]), 2))
                    f = open(cwd + "/log/PlotTemp.txt", 'a+')
                    f.write("{}\n".format(time.strftime("%X,") + self.receivedMessage))
                    f.close()
                except Exception as e:
                   print('ERROR  $temp received: ', e)

            if self.receivedList[0] == '$batV':
                try:
                    self.batVoltage = (round(float(self.receivedList[1]), 2))
                    f = open(cwd + "/log/PlotBat.txt", 'a+')
                    f.write("{}\n".format(time.strftime("%X,") + self.receivedMessage))
                    f.close()
                except Exception as e:
                    print('ERROR  $batV received: ', e)
                    
            if self.receivedList[0] == '$time':
                #$time,12,21,6,28,7,2018
                try:
                    self.dueTime = self.receivedMessage
                    self.dueTimeHour = self.receivedList[1]
                    self.dueTimeMinute = self.receivedList[2]
                    self.dueTimeSecond = self.receivedList[3]
                    self.dueTimeDay = self.receivedList[4]
                    self.dueTimeMonth = self.receivedList[5]
                    self.dueTimeYear = self.receivedList[6]
                    
                    
                except Exception as e:
                    print('ERROR  $time received: ', e)
                    



            if self.receivedList[0] == '$per':
                try:
                    f = open(cwd + "/log/PlotPer.txt", 'a+')
                    f.write("{}\n".format(self.receivedMessage))
                    f.close()
                except Exception as e:
                    print('ERROR  per: ', e)

            if self.receivedList[0] == '$PwrOff':
                   
                try:
                        self.PowerOffInitiate=True
                        
                    
                except Exception as e:
                        print('ERROR  $PwrOff received: ', e)

        else:
            # print(self.receivedMessage)
            pass

        if self.ReceiveCallback is not None:
            self.ReceiveCallback(self)

