""" THE TIMER PAGE ***************************************************"""
import tkinter as tk
import os
#from controller import myController
from config import cwd
from config import myFrameHeight
from config import myFrameWidth
from tkinter.ttk import Notebook
from tkinter import filedialog
from config import myOS
import pickle




class TimerPage(tk.Frame):
    
    def SliderHourStartGroup_click(self, appClass):
        print(self.SliderHourStartGroup())

    def ButtonBackToMain_click(self, appClass):
        appClass.show_start_page()

    def ButtonSaveSettingToFile_click(self):
        self.settingFileName = filedialog.asksaveasfilename(title="Save As :", initialdir=cwd, initialfile='myrobotsetting.ini', filetypes = [("All", "*"),("File Setting","*.ini")])    
        if len(self.settingFileName) > 0:
            self.fileOnPi = open(self.settingFileName, 'wb')   # Overwrites any existing file.
            pickle.dump(TimerPage(), self.fileOnPi)
        
        

    def ButtonReadSettingFromFile_click(self):
        self.settingFileName = filedialog.askopenfilename(title="Open :", initialdir=cwd,initialfile='myrobotsetting.ini', filetypes = [("All", "*"),("File Setting","*.ini")])    
        if len(self.settingFileName) > 0:
            self.fileOnPi = open(self.settingFileName,'rb') 

            self.app = pickle.load(TimerPage())
            print(self.app)
            
        
    def __init__(self, parent, appClass):
        tk.Frame.__init__(self, parent, height=myFrameHeight, width=myFrameWidth)
 
        self.TabTimer=Notebook(self)
        self.SheetTimer= [None]*5
        for i in range(5):
            self.SheetTimer[i]=tk.Frame(self.TabTimer,width=myFrameWidth,height=380)
            self.TabTimer.add(self.SheetTimer[i],text="Timer "+str(i))

        days_list=['SUNDAY','MONDAY','TUESDAY','WEDNESDAY','THURSDAY','FRIDAY','SATURDAY']
        
        self.imgBack=tk.PhotoImage(file=cwd + "/icons/back1.png")
    
        self.TabTimer.place(x=0, y=0, height=430, width=800)

        self.tk_timerActive = []
        self.tk_timerdaysOfWeek = []
        self.tk_timerStartTimehour = []
        self.tk_timerStopTimehour = []
        self.tk_timerStartTimeMinute = []
        self.tk_timerStopTimeMinute = []
        
        self.tk_timerStartNrLane = []
        self.tk_timerStartRollDir = []
        self.tk_timerStartMowPattern = []
        self.tk_timerStartLaneMaxlengh = []
        self.tk_timerStartDistance = []
        self.tk_Random= []
        self.tk_ByLane= []
        self.tk_Perimeter= []
        self.dayvalue=[0]*5
    
        for i in range(5):
            
            self.tk_timerActive.append(tk.IntVar())
            self.tk_timerdaysOfWeek.append(tk.IntVar())
            self.tk_timerStartTimehour.append(tk.IntVar())
            self.tk_timerStopTimehour.append(tk.IntVar())
            self.tk_timerStartTimeMinute.append(tk.IntVar())
            self.tk_timerStopTimeMinute.append(tk.IntVar())
            self.tk_timerStartNrLane.append(tk.IntVar())
            self.tk_timerStartRollDir.append(tk.IntVar())
            self.tk_timerStartMowPattern.append(tk.IntVar())
            self.tk_timerStartLaneMaxlengh.append(tk.IntVar())
            self.tk_timerStartDistance.append(tk.IntVar())
    


        self.tk_timerDayVar=[[None] * 7 for i in range(5)]

   

        ChkBtnDayGroup = [[None] * 7 for i in range(5)]
        ChkBtnEnableGroup=[None]*5
        FrameStartGroup=[None]*5
        FrameStopGroup=[None]*5
        SliderHourStartGroup=[None]*5
        SliderMinuteStartGroup=[None]*5
        SliderHourStopGroup=[None]*5
        SliderMinuteStopGroup=[None]*5
        SliderStartNrLaneGroup=[None]*5
        SliderStartMowPatternGroup=[None]*5
        SliderStartLaneMaxlenghGroup=[None]*5
        SliderStartDistanceGroup=[None]*5
        FrameRollDir=[None]*5
        FrameMowPattern=[None]*5
        FrameLaneParameter=[None]*5

        RdBtn_Random=[None]*5
        RdBtn_ByLane=[None]*5
        RdBtn_Perimeter=[None]*5



        for i in range(5):
            self.tk_timerStartMowPattern[i].set(0)
            ChkBtnEnableGroup[i] = tk.Checkbutton(self.SheetTimer[i],text="Enable this Timer",font=("Arial", 14), fg='red',variable=self.tk_timerActive[i],anchor = 'w')
            ChkBtnEnableGroup[i].place(x=20, y=0, height=25, width=380)
    
            FrameStartGroup[i] = tk.Frame(self.SheetTimer[i],borderwidth="1",relief=tk.SUNKEN)
            FrameStartGroup[i].place(x=20, y=30, height=115, width=350)
            startText="Mower START at " + str(self.tk_timerStartTimehour[i].get()) +":" +str(self.tk_timerStartTimeMinute[i].get())
            tk.Label(FrameStartGroup[i], text=startText,font=("Arial", 12), fg='green').place(x=0,y=10, height=15, width=300)





            SliderHourStartGroup[i] = tk.Scale(FrameStartGroup[i],from_=0, to=23,command = lambda: self.SliderHourStartGroup_click(appClass),variable=self.tk_timerStartTimehour[i],relief=tk.SOLID,orient='horizontal')
            
            
            
            
            SliderHourStartGroup[i].place(x=80, y=30, height=40, width=265)
            SliderMinuteStartGroup[i] = tk.Scale(FrameStartGroup[i],from_=0, to=59,variable=self.tk_timerStartTimeMinute[i],relief=tk.SOLID,orient='horizontal')
            SliderMinuteStartGroup[i].place(x=80, y=70, height=40, width=265)
            tk.Label(FrameStartGroup[i], text='Hour :',font=("Arial", 14), fg='green').place(x=10,y=30, height=40, width=70)
            tk.Label(FrameStartGroup[i], text='Minute :',font=("Arial", 14), fg='green').place(x=10,y=70, height=40, width=70)
    

            FrameStopGroup[i] = tk.Frame(self.SheetTimer[i],borderwidth="1",relief=tk.SUNKEN)
            FrameStopGroup[i].place(x=380, y=30, height=115, width=350)
            stopText="Mower STOP at " + str(self.tk_timerStopTimehour[i].get()) +":" +str(self.tk_timerStopTimeMinute[i].get())
            tk.Label(FrameStopGroup[i], text=stopText,font=("Arial", 12), fg='green').place(x=0,y=10, height=15, width=300)
            SliderHourStopGroup[i] = tk.Scale(FrameStopGroup[i],from_=0, to=23,variable=self.tk_timerStopTimehour[i],relief=tk.SOLID,orient='horizontal')
            SliderHourStopGroup[i].place(x=80, y=30, height=40, width=265)
            SliderMinuteStopGroup[i] = tk.Scale(FrameStopGroup[i],from_=0, to=59,variable=self.tk_timerStopTimeMinute[i],relief=tk.SOLID,orient='horizontal')
            SliderMinuteStopGroup[i].place(x=80, y=70, height=40, width=265)
            tk.Label(FrameStopGroup[i], text='Hour :',font=("Arial", 14), fg='green').place(x=10,y=30, height=40, width=70)
            tk.Label(FrameStopGroup[i], text='Minute :',font=("Arial", 14), fg='green').place(x=10,y=70, height=40, width=70)

            tk.Label(self.SheetTimer[i],text="Where to start on the Perimeter :",fg='green').place(x=10,y=180, height=20, width=780)
            SliderStartDistanceGroup[i]= tk.Scale(self.SheetTimer[i],from_=0, to=400,font=("Arial", 8),variable=self.tk_timerStartDistance[i],relief=tk.SOLID,orient='horizontal')
            SliderStartDistanceGroup[i].place(x=10,y=200, height=35, width=780)


   
            FrameMowPattern[i] = tk.Frame(self.SheetTimer[i],borderwidth="1",relief=tk.SUNKEN)
            FrameMowPattern[i].place(x=410, y=240, height=120, width=180)
            tk.Label(FrameMowPattern[i],text="MOW PATTERN :",fg='green').pack(side='top',anchor='w')
            RdBtn_Random[i]=tk.Radiobutton(FrameMowPattern[i], text="Random", variable=self.tk_timerStartMowPattern[i], value=0).pack(side='top',anchor='w')
            RdBtn_ByLane[i]=tk.Radiobutton(FrameMowPattern[i], text="By Lane", variable=self.tk_timerStartMowPattern[i], value=1).pack(side='top',anchor='w')
            RdBtn_Perimeter[i]=tk.Radiobutton(FrameMowPattern[i], text="Perimeter", variable=self.tk_timerStartMowPattern[i], value=2).pack(side='top',anchor='w')
    
            FrameLaneParameter[i] = tk.Frame(self.SheetTimer[i],borderwidth="1",relief=tk.SUNKEN)
            FrameLaneParameter[i].place(x=20, y=240, height=120, width=380)
            tk.Label(FrameLaneParameter[i],text="Maximum Lane Lenght :",fg='green').place(x=10,y=0, height=20, width=360)
            SliderStartLaneMaxlenghGroup[i]= tk.Scale(FrameLaneParameter[i],from_=1, to=30,font=("Arial", 8),variable=self.tk_timerStartLaneMaxlengh[i],relief=tk.SOLID,orient='horizontal')
            SliderStartLaneMaxlenghGroup[i].place(x=10,y=20, height=35, width=360)
    
            tk.Label(FrameLaneParameter[i], text='Roll Dir',font=("Arial", 12), fg='green').place(x=10,y=60, height=15, width=80)
            RdBtn_Right=tk.Radiobutton(FrameLaneParameter[i], text="Right",variable=self.tk_timerStartRollDir[i], value=0).place(x=10,y=75, height=20, width=80)
            RdBtn_Left=tk.Radiobutton(FrameLaneParameter[i], text="Left ",variable=self.tk_timerStartRollDir[i], value=1).place(x=10,y=95, height=20, width=80)


            tk.Label(FrameLaneParameter[i],text="START Lane",font=("Arial", 12), fg='green').place(x=220,y=60, height=15, width=90)
            SliderStartNrLaneGroup[i]= tk.Scale(FrameLaneParameter[i],from_=1, to=3,variable=self.tk_timerStartNrLane[i],relief=tk.SOLID,orient='horizontal').place(x=230,y=75, height=40, width=70)

            for j in range(7):
                self.tk_timerDayVar[i][j]=tk.BooleanVar()
                ChkBtnDayGroup[i][j] = tk.Checkbutton(self.SheetTimer[i],text=days_list[j],variable=self.tk_timerDayVar[i][j],relief=tk.GROOVE,borderwidth="1",anchor = 'w')
                ChkBtnDayGroup[i][j].place(x=110*j+10, y=150, height=25, width=120) 

        self.ButtonBack1 = tk.Button(self, image=self.imgBack, command = lambda: self.ButtonBackToMain_click(appClass))
        self.ButtonBack1.place(x=myFrameWidth -120, y=myFrameHeight -120, height=120, width=120)
        
        self.ButtonSaveSettingToFile = tk.Button(self, image=self.imgBack, command = lambda: self.ButtonSaveSettingToFile_click())
        self.ButtonSaveSettingToFile.place(x=myFrameWidth -240, y=myFrameHeight -120, height=120, width=120)
        self.ButtonReadSettingFromFile = tk.Button(self, image=self.imgBack, command = lambda: self.ButtonReadSettingFromFile_click(appClass))
        self.ButtonReadSettingFromFile.place(x=myFrameWidth -360, y=myFrameHeight -120, height=120, width=120)

    def OnReceiveSerialData(self,dataObj):
        if dataObj.dueTime !="":
            #$time,12,21,6,28,7,2018 what is receive from due
            cmdline="sudo date -s " + "'" + dataObj.dueTimeYear + "-"
            cmdline=cmdline + dataObj.dueTimeMonth + "-" + dataObj.dueTimeDay +" "
            cmdline=cmdline + dataObj.dueTimeHour +":" + dataObj.dueTimeMinute + ":"
            cmdline=cmdline + dataObj.dueTimeSecond +"'"
            
            #print (cmdline)
            if myOS == "Linux":
                print("Set the new time and date to PI" )
                print(dataObj.dueTime)
                os.system(cmdline)

            #reset all value
            
            dataObj.dueTime=""
            dataObj.dueTimeHour = 0
            dataObj.dueTimeMinute = 0
            dataObj.dueTimeSecond = 0
            dataObj.dueTimeDay = 0
            dataObj.dueTimeMonth = 0
            dataObj.dueTimeYear = 0

#app = TimerPage()
print("coucou")
#print(app)
            




